; this is the event handler routine the the Prowess Sbasic interface
; v. 1.02 	1996 May 06 14:06:01
; Copyright (c)  W Lenerz 1996


	section	text

	include	asm_includes_asm
	xref	rt_fp		; return fp to Basic (asm_lib_returnparams)
	xref	float		; make D2 into floating point  "


;---------------------------------
; a macro only used here, makes the different routines for the keywords
do_name	macro	name,value

	  xdef	 [name]_rout
[name]_rout LEA	 act_[name],A2	 ; get routine
	  BRA	 ret_val
act_[name]  MOVE.L	D1,-(A7)
	  MOVEQ	 #[value],D1	; this is the routine: put value in D1
	  BRA	 hit_do	         ; rest is common to all

	  endm


	do_name	 hit,0
	do_name	 do,1
	do_name	 rd,2
	do_name	 ex,3
	do_name	 mo,4
	do_name	 sc,5
	do_name	 dh,6
	do_name	 dd,7
	do_name	 de,8
	do_name	 da,9
	do_name	 in,10
	do_name	 wa,11
	do_name	 qu,12
	do_name	 he,13
	do_name	 it,14
		      
	do_name	 e1,21
	do_name	 e2,22
	do_name	 e3,23
	do_name	 e4,24
	do_name	 e5,25
	do_name	 e6,26
	do_name	 e7,27
	do_name	 e8,28

;-------------------------------------------
; (leave this here, to avoid branch to next instruction from
; BRA.S hit_do in macro)

ret_val	MOVE.L	A2,D2	        ; this is address of routine
	JMP	rt_fp	        ; and return it to basic


 
; the handlers themselves - we are inside the Prowess event handler routines
; and make an exit to Sbasic

;
; first search for the top of the stack:
; this searches the stack until it finds my watermark
; this is inside the item hit routine
hit_do	MOVEM.L	evtregs,-(A7)	; keep these regs now
	MOVE.L	regsoff+4(A7),D5	; this is the object hit
	MOVE.L	regsoff+8(A7),D4	; additional object
;	 MOVE.L	 D2,D5		 ; keep the object...
;	 MOVE.L	 D3,D4
	MOVE.W	D1,D6		; and the event...
tlp	MOVEQ	#0,D0
	TRAP	#1		; get sysinfo, especially my job ID
	TST.L	D0
	BNE.S	tlp		; oops, redo until ok! (this could loop forever)
	MOVE.L	A7,A1		; A1 points to stack
	MOVE.L	A1,A2
	ADD.L	#memspace,A2	; can't be further away than that
	MOVE.L	#water2,D0	; 2nd watermark, 1st to be searched here
	SWAP	D0		; get upper word first
loop	CMP.W	(A1)+,D0		; is this the 1st part of my watermark?
	BEQ.S	found1		; yes->...
	CMP.L	A1,A2		; do not overshoot the end!
	BEQ	horrible		; oops, HOW COULD THIS HAPPEN?
	BRA.S	loop		; go around again

not_fnd	SWAP	D0		; get upper word back
	MOVE.L	A3,A1		; thats where we were
	BRA.S	loop		; and go around once more

; here we found the first part of a watermark, let's see whether the
; rest is there, too
found1	MOVE.L	A1,A3		; keep this for the time being
	SWAP	D0		; get lower word
	CMP.W	(A1)+,D0		; second half of 1st watermark ok?
	BNE.S	not_fnd		; no->...
	CMP.L	(A1)+,D1		; ok, how about my job ID?
	BNE.S	not_fnd		; no->...
	CMP.L	#water1,(A1)+	; ok, how about 2nd watermark?
	BNE.S	not_fnd		; no ->...

; here we have found the watermark, so we know where the top of the stack is
	MOVE.L	A7,A2		; keep prowess stack
	MOVE.L	A1,D7		; true top of stack
	SUB.L	#28,D7		; point tos as it was when we jumped here
	reset_stk 		; get the Sbasic stack & some regs back now
	MOVE.L	A2,4(A0)		; point to prowess stack as it was
	MOVE.L	A0,A4		; keep this

; now change the two parameters on return
; first the object

	LEA	16(A3),A3 	; point to 3rd parameter
	SUBQ.L	#6,$58(A6)	; this is a floating point variable
	MOVE.L	$58(A6),A1
	MOVE.L	D5,D2
	JSR	float		; convert long into float
	MOVE.W	D0,(A6,A1.L)
	MOVE.L	D2,2(A6,A1.L)
	MOVE.W	$120,A2		; return changed parameter
	JSR	(A2)		; do it
; now the additional object
	ADDQ.L	#8,A3
	MOVE.L	D4,D2
	JSR	float		; convert long into float
	SUBQ.L	#6,$58(A6)
	MOVE.L	$58(A6),A1
	MOVE.W	D0,(A6,A1.L)
	MOVE.L	D2,2(A6,A1.L)
	MOVE.W	$120,A2		; return changed parameter
	JSR	(A2)		; do it
; now the hit/do
	ADDQ.L	#8,A3		; point to last parameter
	SUBQ.L	#2,$58(A6)	; new maths stack
	MOVE.L	$58(A6),A1
	MOVE.W	D6,(A6,A1.L)	; put this on stack
	MOVE.W	$120,A2		; return changed parameter
	JSR	(A2)		; now
;
	MOVE.L	A4,D2		; this is bottom of my allocated memory
	JMP	rt_fp		; return floating point to basic


; horrible: here, my watermark was not found on the stack - so just do
; nothing, but return with an error in D0
horrible	MOVEM.L	(A7)+,evtregs
	MOVEQ	#-9,D0		; show error & return to Prowess
	RTS

	end
