; this is the PW keyword for the Prowess Sbasic interface
; v. 1.02 	1997 Jun 06 15:05:08
; copyright (c) W. Lenerz 1996

****************************************************************************
*
* This is the PW function, and the PWtest function
*
* 1- PW
*
* syntax	: tag=PW("name_of_tag")
*
* where:	tag is the result returned, the tag (or type) needed by Prowess
*	name_of tag is the name of the tag as detailed in the manual, minus
*	the 'PW_' portion. It SHOULD be between quotes, or a string.
*
* 2- PWtest
*
* syntax	: result%=PWtest("name_of_tag")
*
* where:	result% is the result returned:	0 if tag not found
*					1 if tag found
*
*****************************************************************************

	section	text

	xdef	pw
	xdef	pwtest
	xref	getstr		; gets a string passed as parameter
				; (prowess_asm_getstr)
	xref	rt_fp		; return fp value to basic (lib_returnparams)
	xref	rt_int		;  "     int  "    "   "	 "
	xref	strings		; names of types (prowess_asm_tagstrings)
	xref	values		; values of type (prowess_asm_tagvalues)

; regs used during this code:
; D0 = counter
; D1 = length of my string, this is decreased during use
; D2 = length of the current subword
; D3 = lsl indicator
; D4 = total token word

; A1 = pointer to (rest of) my string

pwtest	BSR.S	pw1
	BEQ.S	test_ok		; token found->...
	MOVEQ	#0,D4		; signal token not found
	BRA	rt_int		; and return it to basic
test_ok	MOVEQ	#1,D4		; signal token found
	BRA	rt_int		; and return it to basic

pw	BSR.S	pw1		; try to get token
	BEQ	rt_fp		; token, found return it
	RTS			; oops, return with error
pw1	BSR	getstr		; get the string D1 = length
	MOVE.W	D1,D0		; keep length
	MOVE.L	A1,A3
	BRA.S	up_case
uc_lp1	AND.B	#$DF,(A3)+	; make sure that string is in upper...
up_case	DBF	D0,uc_lp1 	; ...case for the comparison
	LEA	strings,A0	; start with this block
	MOVEM.L	D1/A1,-(A7)
	
block	MOVEQ	#24,D3		; index used for shifts: move up unto top
	MOVEQ	#0,D4		; this will be the final token word
	MOVEQ	#0,D5
biglp	MOVEQ	#0,D0		; counter
	BSR.S	get_subword	; now get length of subword into D2, A3 points to next subword
	MOVE.L	A0,A2		; point to token strings
	ADDQ.L	#4,A2		; jump over pointer to values
loop	ADDQ.L	#1,D0		; increase counter
	MOVE.W	(A2)+,D5		; length of this string
	BEQ.S	no_type		; if 0, end of string list - this string was not found!
	BLT.S	nxt_block
	MOVE.L	A2,A4		; keep
	CMP.W	D2,D5		; same length?
	BNE.S	not_fnd		; no, so go around once more->...
	MOVE.L	D5,D6
	MOVE.L	A1,A5		; A5 =  string
	BRA.S	compare		; do dbf loop
cp_lp1	CMPM.B	(A2)+,(A5)+	; is this the same?
	BNE.S	not_fnd		; no; so do next
compare	DBF	D6,cp_lp1

; if we come here, we found the subword!
	LSL.L	D3,D0		; shift up
	ADD.L	D0,D4		; and add to token word
	SUBQ.W	#8,D3		; next time we shift up a bit less
	SUB.W	D2,D1		; remaining length of string
	BEQ.S	got_it		; there is no more ->..
	SUBQ.W	#1,D1		; and there was a '_'

	BEQ.S	got_it		; no more, so try to find this token->...
	MOVE.L	A3,A1		; point to next sub word
	BRA.S	biglp		; and now get next
nxt_block MOVE.L	(A2),A0		; point to start of new block
	MOVEM.L	(A7),D1/A1
	BRA.S	block		; restart search there now

got_it	ADDQ.L	#8,A7		; forget d1/a1
	MOVE.L	(A0),D2
	MOVE.L	A0,A2
	ADD.L	D2,A2		; point to values now
	SUBQ.L	#4,A2		; adjust now
flp1	ADDQ.L	#4,A2		; jump over value of last possibility, to token
	MOVE.L	(A2)+,D2		; get the token, point to value
	BEQ.S	no_type2		; end of token list - ooops!
	CMP.L	D2,D4		; are we looking for this token?
	BNE.S	flp1		; no, so try next
	MOVE.L	(A2),D2		; type
	MOVEQ	#0,D0
	RTS

	BRA	rt_fp		; and return D2 as a floating point
		

not_fnd	ADDQ.L	#1,D5		; make sure length is even
	BCLR	#0,D5
	ADD.L	D5,A4		; D3 = next string
	MOVE.L	A4,A2
	BRA.S	loop		; compare next string

no_type	ADDQ.L	#8,A7
no_type2	MOVEQ	#-15,D0		; this was not found!
	RTS


; D0 = counter
; D1 = length of my string, this is diminished during use
; D2 = length of the current subword
; D3 = lsl indicator
; D4 = total token word

; A1 = pointer to (rest of) my string
; A3 = pointer to new subword (at the end of this routine)
get_subword
	MOVE.L	A1,A2
	MOVE.W	D1,D7
	MOVEQ	#0,D2
	SUBQ.W	#1,D7
soop	CMP.B	#'_',(A2)+
	BEQ.S	end_ofsub
	ADDQ.W	#1,D2		; length of this subword
	DBF	D7,soop
end_ofsub MOVE.L	A2,A3		; point to new subword
	RTS

	end




long:	value		    4
word:	if <>0: do function     2
word:	possible value to add   2
