/*
	ProWesS, PROGS Windowing System

	PWQuery

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 14 January 1995
	28.10.1995 added PW_SYSTEM_GSTATE query
	26.11.1995 PW_OBJECT_AUXILIARY now returns the owners auxiliary value
			   (recursively) when the objects auxiliary is NULL
	09.04.1996 added PW_DEFAULT_xx font/fontsize/foreground/background
*/

#include "ProWesS.h"
#include "PWObject.h"
#include "PWTypeDef.h"
#include "private.h"

extern ColourRGB system_paper;
extern ColourRGB system_ink;
extern ColourRGB system_middle;
extern pt		 system_fontsize;
extern char 	 system_font[];


Error PWQuery(PWObject object, int what, void *ret)
{
	if (!object) return ERR_OK;

	switch (what)
	{
	case PW_OBJECT_AUXILIARY :
		while (object && !object->auxiliary)
			object=object->event.region->parentObject;
		*((void **)ret)=object ? object->auxiliary : NULL;
		break;
	case PW_GLOBAL_AUXILIARY :
		*((void **)ret)=object->event.region->system->global;
		break;
	case PW_SYSTEM_GSTATE :
		*((Gstate *)ret)=object->event.region->system->gstate;
		break;

	case PW_DEFAULT_BACKGROUND:
		MEMCopy(sizeof(ColourRGB),&system_paper,ret);
		break;
	case PW_DEFAULT_FOREGROUND:
		MEMCopy(sizeof(ColourRGB),&system_ink,ret);
		break;
	case PW_DEFAULT_MIDDLEGROUND:
		MEMCopy(sizeof(ColourRGB),&system_middle,ret);
		break;
	case PW_DEFAULT_FONT:
		MEMCopy(PF_MAXFONTNAME,system_font,ret);
		break;
	case PW_DEFAULT_FONTSIZE:
		*((pt *)ret)=system_fontsize;
		break;
	default :
		if (object->type->PWQuery)
			return object->type->PWQuery(object,what,ret);
		else
			return ERR_IPAR;
	}
	return ERR_OK;
}
